commit 1fd60ee5a7012b4a77ef8385bdc99f65b24cdf9e
Author: freddy77 <freddy77>
Date:   Fri Oct 17 08:56:39 2008 +0000

    enable wide characters from server

diff --git a/ChangeLog b/ChangeLog
index 30bfacd..1bb4cd8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Oct 17 10:55:56 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/odbc/odbc.c:
+	- enable wide characters from server
+
 Fri Oct 17 10:37:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsiconv.h src/tds/iconv.c:
 	- add tds_iconv_get to allow multiple client charsets
@@ -715,4 +719,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2625 2008/10/17 08:39:15 freddy77 Exp $
+$Id: ChangeLog,v 1.2626 2008/10/17 08:56:39 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 1df2cad..1dd8bc3 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -34,12 +34,73 @@
 
 #include "tdsodbc.h"
 #include "tdsconvert.h"
+#include "tdsiconv.h"
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.55 2008/10/17 08:30:03 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.56 2008/10/17 08:56:39 freddy77 Exp $");
+
+#if SIZEOF_SQLWCHAR == 2
+# if WORDS_BIGENDIAN
+#  define ODBC_WIDE_NAME "UCS-2BE"
+# else
+#  define ODBC_WIDE_NAME "UCS-2LE"
+# endif
+#elif SIZEOF_SQLWCHAR == 4
+# if WORDS_BIGENDIAN
+#  define ODBC_WIDE_NAME "UCS-4BE"
+# else
+#  define ODBC_WIDE_NAME "UCS-4LE"
+# endif
+#else
+#error SIZEOF_SQLWCHAR not supported !!
+#endif
+
+static SQLLEN
+odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen)
+{
+	const char *ib;
+	char *ob;
+	size_t il, ol, err, char_size;
+
+	TDSSOCKET *tds = stmt->dbc->tds_socket;
+
+	const TDSICONV *conv = curcol->char_conv;
+	if (!conv)
+		conv = tds->char_convs[client2server_chardata];
+	if (desttype == SQL_C_WCHAR) {
+		/* SQL_C_WCHAR, convert to wide encode */
+		conv = tds_iconv_get(tds, ODBC_WIDE_NAME, conv->server_charset.name);
+	}
+
+	ib = src;
+	il = srclen;
+	ob = dest;
+	ol = 0;
+	char_size = desttype == SQL_C_CHAR ? 1 : SIZEOF_SQLWCHAR;
+	if (destlen >= char_size) {
+		ol = destlen - char_size;
+		memset(&conv->suppress, 0, sizeof(conv->suppress));
+		err = tds_iconv(tds, conv, to_client, &ib, &il, &ob, &ol);
+		ol = ob - dest;
+		if (curcol)
+			curcol->column_text_sqlgetdatapos += ib - src;
+		/* terminate string */
+		memset(ob, 0, char_size);
+	}
+
+	/* returned size have to take into account buffer left unconverted */
+	if (il == 0 || (conv->client_charset.min_bytes_per_char == conv->client_charset.max_bytes_per_char
+	    && conv->server_charset.min_bytes_per_char == conv->server_charset.max_bytes_per_char)) {
+		ol += il * conv->client_charset.min_bytes_per_char / conv->server_charset.min_bytes_per_char;
+	} else {
+		/* TODO convert and discard ?? or return proper SQL_NO_TOTAL values ?? */
+		return SQL_NO_TOTAL;
+	}
+	return ol;
+}
 
 SQLLEN
 odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
@@ -112,6 +173,20 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		ores.n.scale = 0;
 	}
 
+	if (is_char_type(srctype)) {
+		if (desttype == SQL_C_CHAR || desttype == SQL_C_WCHAR)
+			return odbc_convert_char(stmt, curcol, src, srclen, desttype, dest, destlen);
+		if (is_unicode_type(srctype)) {
+			/*
+			 * TODO convert to single and then process normally.
+			 * Here we processed SQL_C_BINARY and SQL_C_*CHAR so only fixed types are left
+			 */
+		}
+	}
+
+	/*
+	 * TODO support SQL_C_WCHAR converting when needed
+	 */
 	if (desttype == SQL_C_CHAR) {
 		switch (srctype) {
 		case SYBLONGBINARY:
@@ -163,6 +238,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 			 * odbc always terminate but do not overwrite 
 			 * destination buffer more than needed
 			 */
+			/* TODO check for source !!! */
 			if (curcol)
 				curcol->column_text_sqlgetdatapos += binary_conversion ? cplen / 2 : cplen;
 			dest[cplen] = 0;
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0b46fd0..1c9cfee 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.501 2008/10/17 08:30:03 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.502 2008/10/17 08:56:39 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -371,9 +371,7 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
-#ifdef ENABLE_DEVELOPING
 	dbc->tds_socket->use_iconv = 0;
-#endif
 	tds_set_parent(dbc->tds_socket, (void *) dbc);
 
 	/* Set up our environment change hook */
@@ -3667,7 +3665,7 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				} else {
 					data_ptr += odbc_get_octet_len(c_type, drec_ard) * curr_row;
 				}
-				len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
+				len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->on_server.column_type, colinfo->on_server.column_size),
 						      src, srclen, c_type, data_ptr, drec_ard->sql_desc_octet_length, drec_ard);
 				if (len == SQL_NULL_DATA) {
 					row_status = SQL_ROW_ERROR;
@@ -4717,7 +4715,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 
 			srclen = colinfo->column_cur_size;
 		}
-		nSybType = tds_get_conversion_type(colinfo->column_type, colinfo->column_size);
+		nSybType = tds_get_conversion_type(colinfo->on_server.column_type, colinfo->on_server.column_size);
 		if (fCType == SQL_C_DEFAULT)
 			fCType = odbc_sql_to_c_type_default(stmt->ird->records[icol - 1].sql_desc_concise_type);
 		if (fCType == SQL_ARD_TYPE) {

